//Iclass.cc
//
// example class
//
// copyright 1998, by Thomas Weldon,
// allrights reserved
//
//
// Students in eegr6118 may make copies and modify them 
//for the purposes of their course  projects during spring 1996.
//Any other use of this file is prohibited.
//


#include "Iclass.h"

//   
//    BASIC *******************************************
//   


Iclass::Iclass()			//default constructor
{
	Ixdim = 2;
	Iydim = 2;
 	Iarray = new unsigned char[4];		//why not
	Iname = new  char[strlen("unnamed")+10];
	strcpy(Iname,"unnamed");
}

//    Function: Iclass::Iclass(int x, int y)  
//    		partial constructor, allocates memory, name="unnamed"
//    		Example: Iclass a(2,2);
Iclass::Iclass(int x, int y)  //partial constructor
{
	set_new_handler(newerr);
if( (x<1) || (y<1) ) // null array
	{
	cout << "null array assignment in Iclass::Iclass(int x, int y)  \n";
	cout << " x=" << x<< " y=" <<y <<"\n";
	exit(1);
	}
else	{
	
	Ixdim = x;
	Iydim = y;
	Iarray = new unsigned char[x * y];
	for (int xx = 0; xx < Ixdim; xx++)
		for (int yy = 0; yy < Iydim ; yy++)
		*(Iarray + xx * Iydim + yy) = 0;
	Iname = new  char[strlen("unnamed")+1];
	strcpy(Iname,"unnamed");
	}
}


//    
//    Function: Iclass::Iclass(const Iclass& im) 
//    		copy constructor
//    		Example: Iclass a(b);
Iclass::Iclass(Iclass &im)  //copy constructor
{
	set_new_handler(newerr);
if( (im.Ixdim <=  0) || (im.Iydim <= 0) || 
		(im.Iname == ( char *) 0) ||
	 	(im.Iarray ==  (unsigned char *) 0) ) // null array
	{
	cout << "null  assignment in Iclass::Iclass(Iclass& im)  \n";
	cout << " im.Ixdim=" << im.Ixdim<< " im.ydim=" 
	<<im.Iydim << " im.Iarray=" <<im.Iarray <<"\n";
	exit(1);
	}
else	{
	Ixdim = im.Ixdim;
	Iydim = im.Iydim;
	Iarray = new unsigned char[Ixdim*Iydim];
	for (int xx = 0; xx < Ixdim; xx++)
		for (int yy = 0; yy < Iydim ; yy++)
		 *(Iarray + xx * Iydim + yy)= *(im.Iarray + xx * Iydim + yy);
	Iname = new char[strlen(im.name())+1];
	strcpy(Iname,im.name());
	}
}
	

//    
//    Function: Iclass::~Iclass()	
//    		destructor, delete [] Iarray;delete Iname;
Iclass::~Iclass()				//destructor
{
	if ( (Iarray == (unsigned char *) 0 ) || (Iname == (char *) 0 ) )
		{cout << "--- warning ~Iclass() of null array\n";}
	delete Iarray;
	delete Iname;
} 


//   
//    GET DATA FROM OBJECT *******************************************
//   

//    
//    Function: unsigned char Iclass::getel(int x, int y)
//    		returns value of element x,y in Iclass
//    		Example: i.getel(1,1);
unsigned char Iclass::getel(int x, int y)
{
 if ( (x >= 0) && (x < Ixdim) && (y >= 0) && (y < Iydim))
 	return *(Iarray + x * Iydim + y);
 else
	{cout << "access element Iclass::getel(int x, int y)" << x << "," 
	<< y << " out of range in Iarray " << Iname << "\n"; exit(1);}
}


//    
//    LOAD DATA INTO OBJECT ************************************************
//    

//    
//    Function:  void Iclass::setel(int x, int y, unsigned char c)
//    		sets value of element x,y in Iclass to c
//    
void Iclass::setel(int x, int y, unsigned char c)
{
 if ( (x >= 0) && (x < Ixdim) && (y >= 0) && (y < Iydim))
 	*(Iarray + x * Iydim + y)=c;
 else
	{cout << "access element Iclass::setel(int x, int y, unsigned char c)" << x << "," 
	<< y << " out of range in Iarray " << Iname << "\n"; exit(1);}
}

void Iclass::dplus(int x, int y, unsigned char g)
{
 if ( (x >= 5) && (x < Ixdim -5) && (y >= 5) && (y < Iydim-5))
 	{
	for (int xx = x-3; xx < x+3; xx++)
		*(Iarray + xx * Iydim + y) = g;
	for (int yy = y-3; yy < y+3 ; yy++)
		*(Iarray + x * Iydim + yy) = g;

	}

 else
	{cout << "access element Iclass::dplus(int x, int y, int g)" << x << "," 
	<< y << " out of range in Iarray " << Iname << "\n"; exit(1);}
}


//    
//    IO ************************************************
//    


//     
//     Function: void Iclass::loadimage( char * name)
//     		loads a file into an image array
//     		Example: Iclass i5(2,2);
//     		i5.loadimage("file.img");
//     		
void Iclass::loadimage( char * name)	//load image file
{
//cout <<"enter loadimage\n";
if( (Ixdim ==  0) || (Iydim == 0) ||
	 (Iarray == (unsigned char *)  0) ||
	(name == (char *) 0)  ) // null array
	{
	cout << "null array assignment in Iclass::loadimage( unsigned char * name)  \n";
	cout << " Ixdim=" << Ixdim<< " Iydim=" 
	<<Iydim << " Iarray=" <<Iarray <<"\n";
	exit(1);
	}
else	
if( (name == (char *) 0) || (strlen(name)<1) )
	{cout << "bad filename in Iclass::loadimage(  char * name)\n";
	cout << "stringlength=" <<strlen(name)<<" name="<<name<<"\n";
	}
else
	{
	int size;
	unsigned char * p;
	char * cp;
	p= (*this).Iarray;
	size=(*this).Ixdim * (*this).Iydim;

	ifstream  infile;
	infile.open( name );
	if ( infile.fail() )
		{
		fputs("ERROR void Iclass::loadimage( char * name)", stderr);
		fprintf(stderr, "  file name=%s ", name);
		}
	infile.read( (char *) p,size);
	infile.close();

	}	
}



//     
//     Function: void Iclass::writeimage( char * name)
//     		writes image array to a file
//     		Example: Iclass i5(2,2);
//     		i5.writeimage("file.img");
//     		
void Iclass::writeimage( char * name)	//save image file
{
if( (Ixdim ==  0) || (Iydim == 0) || 
	(Iarray ==  (unsigned char *) 0) ||
	(name == (char *) 0) ) // null array
	{
	cout << "null array assignment in Iclass::writeimage( unsigned char * name)  \n";
	cout << " Ixdim=" << Ixdim<< " Iydim=" 
	<<Iydim << " Iarray=" <<Iarray <<"\n";
	exit(1);
	}
else	
if( (name == (char *) 0) || (strlen(name)<1) )
	{cout << "bad filename in Iclass::writeimage( unsigned char * name)\n";
	cout << "stringlength=" <<strlen(name)<<" name="<<name<<"\n";
	}
else
	{
	int size;
	unsigned char * p;
	p= (*this).Iarray;

	size=(*this).Ixdim * (*this).Iydim;

	ofstream outfile;
	outfile.open(name);
	outfile.write( (char *) p,size);
	if (outfile.fail())
		{cout << "failure writing "<<
		Ixdim<< "x" << Iydim << " file " << name << 
		" in Iclass::writeimage( char * name) \n";
		exit(1);}
	outfile.close();
	}	
}




//    
//    Functions ************************************************
//    



//    
//    Function: Iclass&  Iclass::operator=(Iclass& im)
//    		overloaded equals operator:
//		not very sophisticated
//    
Iclass&  Iclass::operator=(Iclass& im)
{
	set_new_handler(newerr);

if( (im.Ixdim ==  0) || (im.Iydim == 0) ||
	(im.name() ==  ( char *) 0) || 
	(im.Iarray ==  (unsigned char *) 0)) // null array
	{
	cout << "null array assignment in Iclass::operator= \n";
	cout << " im.Ixdim=" << im.Ixdim<< " im.Iydim=" 
	<<im.Iydim << " im.Iarray=" <<im.Iarray <<"\n";
	exit(1);
	}
else
	{
	Ixdim = im.Ixdim ;
	Iydim = im.Iydim  ;
	if(Iarray != (unsigned char *) 0) delete  Iarray;
	Iarray = new unsigned char[Ixdim*Iydim];
	for (int xx = 0; xx < Ixdim; xx++)
		for (int yy = 0; yy < Iydim ; yy++)
		 *(Iarray + xx * Iydim + yy)= *(im.Iarray + xx * Iydim + yy);
	if(Iname != (char *) 0) delete Iname;
	Iname = new  char[strlen(im.name())+1];
	strcpy(Iname,im.name());
	return *this;
	}

}



//    
//    Function: Iclass  Iclass::operator+(int x)
//    		add int value to all Iclass elements
//
Iclass  Iclass::operator+(int x)
{
if( (Ixdim ==  0) || (Iydim == 0) || 
		(Iarray== (unsigned char *) 0) ) // null array

	{
	cout << "null array assignment in Iclass::operator+(int x) \n";
	exit(1);
	}

else	
	{
	unsigned char cx=(unsigned char ) x;
	Iclass im = *this;
	for (int xx = 0; xx < Ixdim; xx++)
		for (int yy = 0; yy < Iydim ; yy++)
		 *(im.Iarray + xx * im.Iydim + yy)
		=  *(Iarray + xx * Iydim + yy)+cx;
	return im;
	}
}


//    
//    Function: Iclass  Iclass::operator+(Iclass& x)
//
Iclass  Iclass::operator+(Iclass& x)
{
if( (Ixdim ==  0) || (Iydim == 0) || (Iarray== ( unsigned char *) 0) ||
		(x.Ixdim ==  0) || (x.Iydim == 0) ||
		 (x.Iarray== ( unsigned char *) 0) ) // null array
	{
	cout << "null array assignment in Iclass::operator+(Iclass& x) \n";
	exit(1);
	}
else
if( (Ixdim ==  x.Ixdim) && (Iydim == x.Iydim) )  //same size array
	{
	Iclass im = *this;
	for (int xx = 0; xx < Ixdim; xx++)
		for (int yy = 0; yy < Iydim ; yy++)
		 *(im.Iarray + xx * im.Iydim + yy)= 
		*(Iarray + xx * Iydim + yy) +(*(x.Iarray + xx * x.Iydim + yy));
	if (Iname != (char *) 0) delete Iname;
	Iname = new char[strlen("unamed")+1];
	strcpy(Iname,"unamed");
	return im;
	}
else 
	{
	cout << "error dropthrough all tests in Iclass::operator+(Iclass x) \n";
	exit(1);
	}
}



